"""The main file for the reconstruction.
This file should NOT be modified except the body of the 'run_reconstruction' function.
Students should only call their functions (declared in others files of src/) in it.
"""


import numpy as np

from src.forward_model import CFA

# Import the files needed for the reconstruction like:
# from src.file import function_1
from src.demo_reconstructions import naive_interpolation


def run_reconstruction(y: np.ndarray, cfa: str) -> np.ndarray:
    """Performs demosaicking on y.

    Args:
        y (np.ndarray): Mosaicked image to be reconstructed.

    Returns:
        np.ndarray: Demosaicked image.
    """
    # Performing the reconstruction.
    # TODO

    ######################################## Demo code ########################################
    input_shape = (y.shape[0], y.shape[1], 3)
    op = CFA(cfa, input_shape)


    res = naive_interpolation(op, y)
    ###########################################################################################

    return res


####
####
####

####      ####                ####        #############
####      ######              ####      ##################
####      ########            ####      ####################
####      ##########          ####      ####        ########
####      ############        ####      ####            ####
####      ####  ########      ####      ####            ####
####      ####    ########    ####      ####            ####
####      ####      ########  ####      ####            ####
####      ####  ##    ######  ####      ####          ######
####      ####  ####      ##  ####      ####    ############
####      ####  ######        ####      ####    ##########
####      ####  ##########    ####      ####    ########
####      ####      ########  ####      ####
####      ####        ############      ####
####      ####          ##########      ####
####      ####            ########      ####
####      ####              ######      ####

# 2023
# Authors: Mauro Dalla Mura and Matthieu Muller
